// This is the main project file for VC++ application project 
// generated using an Application Wizard.

#include "stdafx.h"

#using <mscorlib.dll>

using namespace System;

using namespace System::Runtime::InteropServices;

typedef struct _SYSTEMTIME {
    short wYear;
    short wMonth;
    short wDayOfWeek;
    short wDay;
    short wHour;
    short wMinute;
    short wSecond;
    short wMilliseconds;
} SYSTEMTIME;


SYSTEMTIME MakeSystemTimeFromDateTime(DateTime dt)
{
    SYSTEMTIME st;
    st.wYear = dt.get_Year();
    st.wMonth = dt.get_Month();
    st.wDayOfWeek = dt.get_DayOfWeek();
    st.wDay = dt.get_Day();
    st.wHour = dt.get_Hour();
    st.wMinute = dt.get_Minute();
    st.wSecond = dt.get_Second();
    st.wMilliseconds = dt.get_Millisecond();

    return st;
}


__gc public class SYSTEMTIME_CustomMarshaler : public ICustomMarshaler
{
public:
    //this class has been implemented one-way only
    //do not use MarshalNativeToManaged, CleanUpManagedData, or GetNativeDataSize
    //SYSTEMTIME_CustomMarshaler(void) ;
    //~SYSTEMTIME_CustomMarshaler(void);
    static ICustomMarshaler* GetInstance(String* cookie);
    IntPtr MarshalManagedToNative(Object* pDateTime);
    void CleanUpNativeData(IntPtr pNativeData);
    Object* MarshalNativeToManaged(IntPtr pNativeData){return 0;};
    void CleanUpManagedData(Object* ManagedObj){};
    int GetNativeDataSize(){return 0;};
private:
    //singleton pattern
    static SYSTEMTIME_CustomMarshaler* marshaler = 0;
};

ICustomMarshaler* SYSTEMTIME_CustomMarshaler::GetInstance(String* cookie)
{
    if (!marshaler)
        marshaler =  new SYSTEMTIME_CustomMarshaler();
    return marshaler;
}

IntPtr SYSTEMTIME_CustomMarshaler::MarshalManagedToNative(Object* pDateTime)
{
    // allocate memory for the struct preceded by an int
   int size = sizeof(SYSTEMTIME)+sizeof(int);
   IntPtr ptrBlock = (Marshal::AllocCoTaskMem(size)).ToPointer();

   // get pointer to start of struct allocation
   int offset = ptrBlock.ToInt32()+sizeof(int);
   IntPtr ptrST(offset); 

   // cast start of overall allocation and write 1 (object count)
   int __nogc * pi = (int __nogc *)ptrBlock.ToPointer();
   *pi = 1;

   //convert IntPtr kind of pointer to actual C++ pointer
   SYSTEMTIME* pst = static_cast<SYSTEMTIME*>(ptrST.ToPointer());
   
   //unbox object pointer
   __box DateTime* bdt = static_cast<__box DateTime*>(pDateTime);
   DateTime dt = *bdt;
   
   //use existing helper function
   *pst = MakeSystemTimeFromDateTime(dt);
   
   //marshaler wants IntPtr kind of pointer to start of struct
   return ptrST;
}

void SYSTEMTIME_CustomMarshaler::CleanUpNativeData(IntPtr pNativeData)
{
   // convert IntPtr kind of pointer to actual C++ pointer
   SYSTEMTIME * pST = static_cast<SYSTEMTIME*>(pNativeData.ToPointer());

   // get pointer to start of struct allocation
   int offset = pNativeData.ToInt32()-sizeof(int);
   IntPtr pBlock(offset);

   // free memory allocated by AllocCoTaskMem
   Marshal::FreeCoTaskMem(pBlock);
}

extern "C" {

[DllImport("legacy", CharSet=CharSet::Ansi)]
bool Log(String* message, 
         [In,MarshalAs(UnmanagedType::CustomMarshaler,
         MarshalTypeRef=__typeof(SYSTEMTIME_CustomMarshaler))]
         __box DateTime* time);

[DllImport("legacy")]
double Add(double num1, double num2);
}

int _tmain()
{
    System::Console::Write(S"1 + 2 is ");
    System::Console::WriteLine(__box( Add(1,2)));
    String* s = new String("Testing with a heap string");
	Log(s, __box(System::DateTime::Now));
	System::Console::WriteLine(S"log succeeded");
	return 0;
}