// ATLUtilities.h : Defines the ATL Server request handler class
//
#pragma once

namespace ATLUtilitiesService
{
// all struct, enum, and typedefs for your webservice should go inside the namespace

// IATLUtilitiesService - web service interface declaration
//
[
	uuid("533AC31D-F3EB-4556-85D6-1F2BAE95A611"), 
	object
]
__interface IATLUtilitiesService
{
	// HelloWorld is a sample ATL Server web service method.  It shows how to
	// declare a web service method and its in-parameters and out-parameters
	[id(1)] HRESULT HelloWorld([in] BSTR bstrInput, [out, retval] BSTR *bstrOutput);
	// TODO: Add additional web service methods here
    [helpstring("method Factor")] HRESULT Factor([in] SHORT i, [in] DOUBLE d, [out,retval] VARIANT_BOOL* result);
};


// ATLUtilitiesService - web service implementation
//
[
	request_handler(name="Default", sdl="GenATLUtilitiesWSDL"),
	soap_handler(
		name="ATLUtilitiesService", 
		namespace="urn:ATLUtilitiesService",
		protocol="soap"
	)
]
class CATLUtilitiesService :
	public IATLUtilitiesService
{
public:
	// This is a sample web service method that shows how to use the 
	// soap_method attribute to expose a method as a web method
	[ soap_method ]
	HRESULT HelloWorld(/*[in]*/ BSTR bstrInput, /*[out, retval]*/ BSTR *bstrOutput)
	{
		CComBSTR bstrOut(L"Hello ");
		bstrOut += bstrInput;
		bstrOut += L"!";
		*bstrOutput = bstrOut.Detach();
		
		return S_OK;
	}
	// TODO: Add additional web service methods here
	[ soap_method ]
    STDMETHOD(Factor)(SHORT i, DOUBLE d, VARIANT_BOOL* result);
}; // class CATLUtilitiesService

} // namespace ATLUtilitiesService
