#pragma once

using namespace System;
using namespace System::Collections;
using namespace System::ServiceProcess;
using namespace System::ComponentModel;


namespace URLChecker
{
    /// <summary> 
    /// Summary for URLCheckerWinService
    /// </summary>
    ///
    /// WARNING: If you change the name of this class, you will need to change the 
    ///          'Resource File Name' property for the managed resource compiler tool 
    ///          associated with all .resx files this class depends on.  Otherwise,
    ///          the designers will not be able to interact properly with localized
    ///          resources associated with this form.
public __gc class URLCheckerWinService : public System::ServiceProcess::ServiceBase 
{
public:
    URLCheckerWinService()
    {
        InitializeComponent();    
    }
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    void Dispose(bool disposing)
    {
        if (disposing && components)
        {
            components->Dispose();
        }
        __super::Dispose(disposing);
    }

private:
    bool stopping;
    int loopsleep; //milliseconds
    Threading::Thread* servicethread;
    DateTime lastrun;
    String* URLs[];
    String* email;
    int interval; //minutes
protected:
    /// <summary>
    /// Set things in motion so your service can do its work.
    /// </summary>
    void OnStart(String* args[])
    {
        Threading::ThreadStart* threadStart = new Threading::ThreadStart(this,CheckURLs);
        servicethread = new Threading::Thread(threadStart);
        servicethread->Start();
    }

    /// <summary>
    /// Stop this service.
    /// </summary>
    void OnStop()
    {     
        stopping = true;
    }

    void CheckURLs()
    {
        Threading::Thread::Sleep(2*60*1000);
        loopsleep = 1000; //milliseconds
        stopping = false;
        //get config info from file
        String* URLString = Configuration::ConfigurationSettings::AppSettings->get_Item("urls"); 
        String* delims = S" ";
        Char delimiter[] = delims->ToCharArray();
        URLs = URLString->Split(delimiter);
        email = Configuration::ConfigurationSettings::AppSettings->get_Item("email"); 
        interval = Configuration::ConfigurationSettings::AppSettings->
            get_Item("minutesinterval")->ToInt16(NULL); 

        //set lastrun to force an immediate check
        lastrun = DateTime::Now - TimeSpan(0,interval+1,0); //hours, minutes, seconds

        Diagnostics::EventLog* log ;
        if (! Diagnostics::EventLog::SourceExists("URLCheckerService") )
            Diagnostics::EventLog::CreateEventSource("URLCheckerService", "URLCheckerLog");
        log = new Diagnostics::EventLog("URLCheckerLog");
        log->Source = "URLCheckerService";

        while (!stopping)
        {
            if (DateTime::Now > lastrun + TimeSpan(0,interval,0))
            { 
                lastrun = DateTime::Now;
                for (int i = 0; i < URLs->Length; i++)
                {
                    try
                    {
                        Net::WebRequest* req = Net::WebRequest::Create(URLs[i]);
                        req->Method = "HEAD";
                        Net::WebResponse* resp = req->GetResponse();
                    }
                    catch (Exception* e)
                    {
                        Text::StringBuilder* body = new Text::StringBuilder(S"");
                        body->Append(S"URLChecker could not reach ");
                        body->Append(URLs[i]);
                        body->Append(Environment::NewLine);
                        body->Append(e->ToString());
                        Web::Mail::SmtpMail::SmtpServer = S"mail2.gregcons.com";
                        Web::Mail::SmtpMail::Send(S"urlchecker@gregcons.com", email, S"URL Checker failure report", body->ToString()); 

                        log->WriteEntry(body->ToString(),Diagnostics::EventLogEntryType::Error);
                    }
                }
            }
            Threading::Thread::Sleep(loopsleep);
        }
    }


private:
    /// <summary>
    /// Required designer variable.
    /// </summary>
    System::ComponentModel::Container *components;

    /// <summary> 
    /// Required method for Designer support - do not modify 
    /// the contents of this method with the code editor.
    /// </summary>	
    void InitializeComponent(void)
    {
        // 
        // URLCheckerWinService
        // 
        this->CanPauseAndContinue = true;
        this->ServiceName = S"URLChecker";

    }		
};
}