// This is the main project file for VC++ application project 
// generated using an Application Wizard.

#include "stdafx.h"

#using <mscorlib.dll>

using namespace System;
using namespace System::Security::Principal;

#include "accesscontrolled.h"
#include "managedaccesscontrolled.h"

// This is the entry point for this application
int _tmain(void)
{
    WindowsIdentity* Identity = WindowsIdentity::GetCurrent();
    WindowsPrincipal* Principal = new WindowsPrincipal(Identity);

    //Print the values.
    Console::WriteLine("Principal Values for current thread:");
    Console::WriteLine("Name: {0}", Principal->Identity->Name);
    Console::WriteLine("Type: {0}", Principal->Identity->AuthenticationType);
    Console::WriteLine("IsAuthenticated: {0}", __box(Principal->Identity->IsAuthenticated));
    Console::WriteLine();
    Console::WriteLine();
    Console::WriteLine("Identity Values for current thread:");
    Console::WriteLine("Name: {0}", Identity->Name);
    Console::WriteLine("Type: {0}", Identity->AuthenticationType);
    Console::WriteLine("IsAuthenticated: {0}", __box(Identity->IsAuthenticated));
    Console::WriteLine("IsAnonymous: {0}", __box(Identity->IsAnonymous));
    Console::WriteLine("IsGuest: {0}", __box(Identity->IsGuest));
    Console::WriteLine("IsSystem: {0}", __box(Identity->IsSystem));
    Console::WriteLine("Token: {0}", Identity->Token.ToString());

    Console::WriteLine();
    String* role = "YOURDOMAIN\\Domain Users";
    if (Principal->IsInRole(role))
        Console::WriteLine("You are a domain user");
    else
        Console::WriteLine("You are not a domain user");

    role = "BUILTIN\\Administrators";
    if (Principal->IsInRole(role))
        Console::WriteLine("You are an administrator");
    else
        Console::WriteLine("You are not an administrator");

    role = "YOURMACHINE\\Experts";
    if (Principal->IsInRole(role))
        Console::WriteLine("You are an Expert on this machine");
    else
        Console::WriteLine("You are not an Expert on this machine");

    AccessControlled* ac = new AccessControlled();
    Console::WriteLine("created the access controlled object");

    AppDomain::CurrentDomain->SetPrincipalPolicy(PrincipalPolicy::WindowsPrincipal);
    ManagedAccessControlled* mac = new ManagedAccessControlled();
    Console::WriteLine("created the managed access controlled object");


    return 0;
}

